AccessLogValve (Tomcat API Documentation)
Keywords: org.apache.catalina.valves.AccessLogValve class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.catalina.valves
Class AccessLogValve

    java.lang.Object
      org.apache.catalina.valves.ValveBase
          org.apache.catalina.valves.AccessLogValve

All Implemented Interfaces:
  javax.management.MBeanRegistration, Contained, Lifecycle, Valve

Direct Known Subclasses:
  ExtendedAccessLogValve, FastCommonAccessLogValve

    public class AccessLogValve

extends ValveBase
implements Lifecycle

Implementation of the Valve interface that generates a web server access log with the detailed line contents matching a configurable pattern. The syntax of the available patterns is similar to that supported by the Apache `mod_log_config` module. As an additional feature, automatic rollover of log files when the date changes is also supported.

Patterns for the logged message may include constant text or any of the following replacement strings, for which the corresponding information from the specified Response is substituted:

- %a - Remote IP address
- %A - Local IP address
- %b - Bytes sent, excluding HTTP headers, or '-' if no bytes were sent
- %B - Bytes sent, excluding HTTP headers
- %h - Remote host name
- %H - Request protocol
- %l - Remote logical username from identd (always returns '-')
- %m - Request method
- %p - Local port
- %q - Query string (prepended with a '?' if it exists, otherwise an empty string
- %r - First line of the request
- %s - HTTP status code of the response
- %S - User session ID
- %t - Date and time, in Common Log Format format
- %u - Remote user that was authenticated
- %U - Requested URL path
- %v - Local server name
- %D - Time taken to process the request, in millis
- %T - Time taken to process the request, in seconds
- %I - current Request thread name (can compare later with stacktraces)

In addition, the caller can specify one of the following aliases for commonly utilized patterns:

- common - `%h %l %u %t "%r" %s %b`
- combined - `%h %l %u %t "%r" %s %b "%{Referer}i" "%{User-Agent}i"`

There is also support to write information from the cookie, incoming header, the Session or something else in the ServletRequest.
It is modeled after the apache syntax:

- `%{xxx}i` for incoming headers
- `%{xxx}o` for outgoing response headers
- `%{xxx}c` for a specific cookie
- `%{xxx}r` xxx is an attribute in the ServletRequest
- `%{xxx}s` xxx is an attribute in the HttpSession

Conditional logging is also supported. This can be done with the `condition` property. If the value returned from ServletRequest.getAttribute(condition) yields a non-null value. The logging will be skipped.

Version:
  $Revision: 769349 $ $Date: 2009-04-28 13:54:10 +0200 (Tue, 28 Apr 2009) $
Author:
  Craig R. McClanahan, Jason Brittain, Remy Maucherat, Takayuki Kaneko, Peter Rossbach

Nested Class Summary
`protected static interface` | `AccessLogValve.AccessLogElement` AccessLogElement writes the partial message into the buffer.
`protected class` | `AccessLogValve.ByteSentElement` write bytes sent, excluding HTTP headers - %b, %B
`protected class` | `AccessLogValve.CookieElement` write a specific cookie - %{xxx}c
`protected class` | `AccessLogValve.DateAndTimeElement` write date and time, in Common Log Format - %t
`protected class` | `AccessLogValve.ElapsedTimeElement` write time taken to process the request - %D, %T
`protected class` | `AccessLogValve.HeaderElement` write incoming headers - %{xxx}i
`protected class` | `AccessLogValve.HostElement` write remote host name - %h
`protected class` | `AccessLogValve.HttpStatusCodeElement` write HTTP status code of the response - %s
`protected class` | `AccessLogValve.LocalAddrElement` write local IP address - %A
`protected class` | `AccessLogValve.LocalPortElement` write local port on which this request was received - %p
`protected class` | `AccessLogValve.LocalServerNameElement` write local server name - %v
`protected class` | `AccessLogValve.LogicalUserNameElement` write remote logical username from identd (always returns '-') - %l
`protected class` | `AccessLogValve.MethodElement` write request method (GET, POST, etc.) - %m
`protected class` | `AccessLogValve.ProtocolElement` write request protocol - %H
`protected class` | `AccessLogValve.QueryElement` write Query string (prepended with a '?'
`protected class` | `AccessLogValve.RemoteAddrElement` write remote IP address - %a
`protected class` | `AccessLogValve.RequestAttributeElement` write an attribute in the ServletRequest - %{xxx}r
`protected class` | `AccessLogValve.RequestElement` write first line of the request (method and request URI) - %r
`protected class` | `AccessLogValve.RequestURIElement` write requested URL path - %U
`protected class` | `AccessLogValve.ResponseHeaderElement` write a specific response header - %{xxx}o
`protected class` | `AccessLogValve.SessionAttributeElement` write an attribute in the HttpSession - %{xxx}s
`protected class` | `AccessLogValve.SessionIdElement` write user session ID - %S
`protected class` | `AccessLogValve.StringElement` write any string
`protected class` | `AccessLogValve.ThreadNameElement` write thread name - %I
`protected class` | `AccessLogValve.UserElement` write remote user that was authenticated (if any), else '-' - %u

Field Summary
`protected java.lang.String` | `condition` Are we doing conditional logging. default false.
`protected java.io.File` | `currentLogFile` The current log file we are writing to.
`protected boolean` | `enabled` enabled this component
`protected java.lang.String` | `fileDateFormat` Date format to place in log file name.
`protected java.text.SimpleDateFormat` | `fileDateFormatter` A date formatter to format a Date into a date in the format "yyyy-MM-dd".
`protected static java.lang.String` | `info` The descriptive information about this implementation.
`protected LifecycleSupport` | `lifecycle` The lifecycle event support for this component.
`protected AccessLogValve.AccessLogElement[]` | `logElements` Array of AccessLogElement, they will be used to make log message.
`protected static java.lang.String[]` | `months` The set of month abbreviations for log messages.
`protected java.lang.String` | `pattern` The pattern used to format our access log lines.
`protected java.lang.String` | `prefix` The prefix that is added to log file filenames.
`protected boolean` | `rotatable` Should we rotate our log file?
`protected StringManager` | `sm` The string manager for this package.
`protected boolean` | `started` Has this component been started yet?
`protected java.lang.String` | `suffix` The suffix that is added to log file filenames.
`protected java.io.PrintWriter` | `writer` The PrintWriter to which we are currently logging, if any.

Fields inherited from class org.apache.catalina.valves.ValveBase
`container, containerLog, controller, domain, mserver, next, oname`

Fields inherited from interface org.apache.catalina.Lifecycle
`AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, DESTROY_EVENT, INIT_EVENT, PERIODIC_EVENT, START_EVENT, STOP_EVENT`

Constructor Summary
`AccessLogValve()`

Method Summary
`void` | `addLifecycleListener(LifecycleListener listener)` Add a lifecycle event listener to this component.
`void` | `backgroundProcess()` Execute a periodic task, such as reloading, etc.
`protected AccessLogValve.AccessLogElement[]` | `createLogElements()` parse pattern string and create the array of AccessLogElement
`LifecycleListener[]` | `findLifecycleListeners()` Get the lifecycle listeners associated with this lifecycle.
`java.lang.String` | `getCondition()` Return whether the attribute name to look for when performing conditional loggging.
`java.lang.String` | `getDirectory()` Return the directory in which we create log files.
`boolean` | `getEnabled()`
`java.lang.String` | `getFileDateFormat()` Return the date format date based log rotation.
`java.lang.String` | `getInfo()` Return descriptive information about this implementation.
`java.lang.String` | `getPattern()` Return the format pattern.
`java.lang.String` | `getPrefix()` Return the log file prefix.
`java.lang.String` | `getSuffix()` Return the log file suffix.
`void` | `invoke(Request request, Response response)` Log a message summarizing the specified request and response, according to the format specified by the `pattern` property.
`boolean` | `isBuffered()` Is the logging buffered
`boolean` | `isCheckExists()` Check for file existence before logging.
`boolean` | `isResolveHosts()` Get the value of the resolve hosts flag.
`boolean` | `isRotatable()` Should we rotate the logs
`void` | `log(java.lang.String message)` Log the specified message to the log file, switching files if the date has changed since the previous log call.
`protected void` | `open()` Open the new log file for the date specified by `dateStamp`.
`void` | `removeLifecycleListener(LifecycleListener listener)` Remove a lifecycle event listener from this component.
`boolean` | `rotate(java.lang.String newFileName)` Rename the existing log file to something else.
`void` | `setBuffered(boolean buffered)` Set the value if the logging should be buffered
`void` | `setCheckExists(boolean checkExists)` Set whether to check for log file existence before logging.
`void` | `setCondition(java.lang.String condition)` Set the ServletRequest.attribute to look for to perform conditional logging.
`void` | `setDirectory(java.lang.String directory)` Set the directory in which we create log files.
`void` | `setEnabled(boolean enabled)`
`void` | `setFileDateFormat(java.lang.String fileDateFormat)` Set the date format date based log rotation.
`void` | `setPattern(java.lang.String pattern)` Set the format pattern, first translating any recognized alias.
`void` | `setPrefix(java.lang.String prefix)` Set the log file prefix.
`void` | `setResolveHosts(boolean resolveHosts)` Set the resolve hosts flag.
`void` | `setRotatable(boolean rotatable)` Set the value is we should we rotate the logs
`void` | `setSuffix(java.lang.String suffix)` Set the log file suffix.
`void` | `start()` Prepare for the beginning of active use of the public methods of this component.
`void` | `stop()` Gracefully terminate the active use of the public methods of this component.

Methods inherited from class org.apache.catalina.valves.ValveBase
`createObjectName, event, getContainer, getContainerName, getController, getDomain, getNext, getObjectName, getParentName, postDeregister, postRegister, preDeregister, preRegister, setContainer, setController, setNext, setObjectName, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### info

    protected static final java.lang.String info

  The descriptive information about this implementation.

  See Also:
    Constant Field Values

### lifecycle

    protected LifecycleSupport lifecycle

  The lifecycle event support for this component.

### months

    protected static final java.lang.String[] months

  The set of month abbreviations for log messages.

### enabled

    protected boolean enabled

  enabled this component

### pattern

    protected java.lang.String pattern

  The pattern used to format our access log lines.

### prefix

    protected java.lang.String prefix

  The prefix that is added to log file filenames.

### rotatable

    protected boolean rotatable

  Should we rotate our log file? Default is true (like old behavior)

### sm

    protected StringManager sm

  The string manager for this package.

### started

    protected boolean started

  Has this component been started yet?

### suffix

    protected java.lang.String suffix

  The suffix that is added to log file filenames.

### writer

    protected java.io.PrintWriter writer

  The PrintWriter to which we are currently logging, if any.

### fileDateFormatter

    protected java.text.SimpleDateFormat fileDateFormatter

  A date formatter to format a Date into a date in the format "yyyy-MM-dd".

### currentLogFile

    protected java.io.File currentLogFile

  The current log file we are writing to. Helpful when checkExists is true.

### condition

    protected java.lang.String condition

  Are we doing conditional logging. default false.

### fileDateFormat

    protected java.lang.String fileDateFormat

  Date format to place in log file name. Use at your own risk!

### logElements

    protected AccessLogValve.AccessLogElement[] logElements

  Array of AccessLogElement, they will be used to make log message.

Constructor Detail

### AccessLogValve

    public AccessLogValve()

Method Detail

### getEnabled

    public boolean getEnabled()

  Returns:
    Returns the enabled.

### setEnabled

    public void setEnabled(boolean enabled)

  Parameters:
    `enabled` - The enabled to set.

### getDirectory

    public java.lang.String getDirectory()

  Return the directory in which we create log files.

### setDirectory

    public void setDirectory(java.lang.String directory)

  Set the directory in which we create log files.

  Parameters:
    `directory` - The new log file directory

### getInfo

    public java.lang.String getInfo()

  Return descriptive information about this implementation.

  Specified by:
    `getInfo` in interface `Valve`
  Overrides:
    `getInfo` in class `ValveBase`

### getPattern

    public java.lang.String getPattern()

  Return the format pattern.

### setPattern

    public void setPattern(java.lang.String pattern)

  Set the format pattern, first translating any recognized alias.

  Parameters:
    `pattern` - The new pattern

### isCheckExists

    public boolean isCheckExists()

  Check for file existence before logging.

### setCheckExists

    public void setCheckExists(boolean checkExists)

  Set whether to check for log file existence before logging.

  Parameters:
    `checkExists` - true meaning to check for file existence.

### getPrefix

    public java.lang.String getPrefix()

  Return the log file prefix.

### setPrefix

    public void setPrefix(java.lang.String prefix)

  Set the log file prefix.

  Parameters:
    `prefix` - The new log file prefix

### isRotatable

    public boolean isRotatable()

  Should we rotate the logs

### setRotatable

    public void setRotatable(boolean rotatable)

  Set the value is we should we rotate the logs

  Parameters:
    `rotatable` - true is we should rotate.

### isBuffered

    public boolean isBuffered()

  Is the logging buffered

### setBuffered

    public void setBuffered(boolean buffered)

  Set the value if the logging should be buffered

  Parameters:
    `buffered` - true if buffered.

### getSuffix

    public java.lang.String getSuffix()

  Return the log file suffix.

### setSuffix

    public void setSuffix(java.lang.String suffix)

  Set the log file suffix.

  Parameters:
    `suffix` - The new log file suffix

### setResolveHosts

    public void setResolveHosts(boolean resolveHosts)

  Set the resolve hosts flag.

  Parameters:
    `resolveHosts` - The new resolve hosts value

### isResolveHosts

    public boolean isResolveHosts()

  Get the value of the resolve hosts flag.

### getCondition

    public java.lang.String getCondition()

  Return whether the attribute name to look for when performing conditional loggging. If null, every request is logged.

### setCondition

    public void setCondition(java.lang.String condition)

  Set the ServletRequest.attribute to look for to perform conditional logging. Set to null to log everything.

  Parameters:
    `condition` - Set to null to log everything

### getFileDateFormat

    public java.lang.String getFileDateFormat()

  Return the date format date based log rotation.

### setFileDateFormat

    public void setFileDateFormat(java.lang.String fileDateFormat)

  Set the date format date based log rotation.

### backgroundProcess

    public void backgroundProcess()

  Execute a periodic task, such as reloading, etc. This method will be invoked inside the classloading context of this container. Unexpected throwables will be caught and logged.

  Specified by:
    `backgroundProcess` in interface `Valve`
  Overrides:
    `backgroundProcess` in class `ValveBase`

### invoke

    public void invoke(Request request,
                       Response response)
                throws java.io.IOException,
                       javax.servlet.ServletException

  Log a message summarizing the specified request and response, according to the format specified by the `pattern` property.

  Specified by:
    `invoke` in interface `Valve`
  Specified by:
    `invoke` in class `ValveBase`
  Parameters:
    `request` - Request being processed
    `response` - Response being processed
  Throws:
    `java.io.IOException` - if an input/output error has occurred
    `javax.servlet.ServletException` - if a servlet error has occurred

### rotate

    public boolean rotate(java.lang.String newFileName)

  Rename the existing log file to something else. Then open the old log file name up once again. Intended to be called by a JMX agent.

  Parameters:
    `newFileName` - The file name to move the log file entry to
  Returns:
    true if a file was rotated with no error

### log

    public void log(java.lang.String message)

  Log the specified message to the log file, switching files if the date has changed since the previous log call.

  Parameters:
    `message` - Message to be logged

### open

    protected void open()

  Open the new log file for the date specified by `dateStamp`.

### addLifecycleListener

    public void addLifecycleListener(LifecycleListener listener)

  Add a lifecycle event listener to this component.

  Specified by:
    `addLifecycleListener` in interface `Lifecycle`
  Parameters:
    `listener` - The listener to add

### findLifecycleListeners

    public LifecycleListener[] findLifecycleListeners()

  Get the lifecycle listeners associated with this lifecycle. If this Lifecycle has no listeners registered, a zero-length array is returned.

  Specified by:
    `findLifecycleListeners` in interface `Lifecycle`

### removeLifecycleListener

    public void removeLifecycleListener(LifecycleListener listener)

  Remove a lifecycle event listener from this component.

  Specified by:
    `removeLifecycleListener` in interface `Lifecycle`
  Parameters:
    `listener` - The listener to add

### start

    public void start()
               throws LifecycleException

  Prepare for the beginning of active use of the public methods of this component. This method should be called after `configure()`, and before any of the public methods of the component are utilized.

  Specified by:
    `start` in interface `Lifecycle`
  Throws:
    `LifecycleException` - if this component detects a fatal error that prevents this component from being used

### stop

    public void stop()
              throws LifecycleException

  Gracefully terminate the active use of the public methods of this component. This method should be the last one called on a given instance of this component.

  Specified by:
    `stop` in interface `Lifecycle`
  Throws:
    `LifecycleException` - if this component detects a fatal error that needs to be reported

### createLogElements

    protected AccessLogValve.AccessLogElement[] createLogElements()

  parse pattern string and create the array of AccessLogElement

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2008 Apache Software Foundation. All Rights Reserved.